<?php

/**
 * cuestionario actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage cuestionario
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cuestionarioActions extends sfActions
{
 
    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' order by tab0.id_cuestionario asc ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_cuestionario = $request['id_cuestionario'];
            $this->logMessage("ID_CUESTIONARIO:".$id_cuestionario);


            /*
             * Variables opcionales
             */
            //id_formato_pago - Para traer asi ya este en el archivo asociado - 20181101
            if (isset($request['id_cuestionario'])) {
                $whereIdCuestionario = " AND tab0.id_cuestionario = " . $id_cuestionario;
            } else {
                $whereIdCuestionario = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            $consulta_sql = <<<EOD
SELECT
tab0.*
FROM (

    SELECT * from RVC_CUESTIONARIO
        
)tab0 
where 1 = 1 
$whereIdCuestionario             
EOD;
            //ejecuta y obtiene el resultado del sql

                /*
                 * Sql que trae los resultados
                 * por los filtros, para totalizar las filas
                 */
                $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;
                $total_record_count = CN_TABLE::executeSQL($sql);
                $total_record_count = $total_record_count[0]["count"];


                //obtener el listado de cuestionarios
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
                //ejecuta y obtiene el resultado del sql
                $resultado = CN_TABLE::executeSQL($sql);
                if(count($resultado) > 0){
                    $respuesta = array();
                    foreach($resultado as $c){
                        $cuestionario = $c;
                        $id = $cuestionario['id_cuestionario']; 
                        $this->logMessage("ID_CUESTIONARIO PARA PREGUNTA:".$id);
                        $sql_preguntas = <<<EOD
SELECT * 
FROM 
    RVC_PREGUNTA_CUESTIONARIO 
where id_cuestionario = $id and estado = 1 
order by numero
EOD;
                        $preguntas = CN_TABLE::executeSQL($sql_preguntas);
                        $cuestionario['numero_preguntas'] = count($preguntas);
                        foreach($preguntas as $p){
                            $cuestionario['id_pregunta_'.$p['numero']] = $p['id_pregunta'];
                            $cuestionario['numero_pregunta_'.$p['numero']] = $p['numero'];
                            $cuestionario['texto_pregunta_'.$p['numero']] = $p['texto'];
                            $cuestionario['si_no_pregunta_'.$p['numero']] = $p['si_no'];
                            $cuestionario['aplica_obs_pregunta_'.$p['numero']] = $p['aplica_obs'];
                            $cuestionario['texto_obs_pregunta_'.$p['numero']] = $p['texto_obs'];
                            $cuestionario['tipo_obs_pregunta_'.$p['numero']] = $p['tipo_obs'];   
                        }
                        
                        array_push($respuesta,$cuestionario);
                    }
                }
                

                $this->status = 0;
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($resultado);
                //$this->list_data = $resultado;
                $this->list_data = $respuesta;
                $this->logMessage("[Cuestionario] Consulta exitosa.");

        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
